Dirac Video Codec

# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

# dirac::PictureParams Class Reference

Parameters for initialising picture class objects.

`#include <common.h>`

Collaboration diagram for dirac::PictureParams:
[legend]

List of all members.

## Public Member Functions

- PictureParams ()
    Default constructor.
- PictureParams (const ChromaFormat &cf, int xlen, int ylen, unsigned int luma_depth, unsigned int chroma_depth)
    Constructor.
- PictureParams (const ChromaFormat &cf, const PictureSort &fs)
    Constructor.
- PictureParams (const SourceParams &sparams)
    Constructor.
- const ChromaFormat & CFormat () const
    Returns the chroma format of the picture.
- int Xl () const
    Returns the picture width.
- int Yl () const
    Returns the picture height.
- int ChromaXl () const
    Returns the chroma width of the picture.
- int ChromaYl () const
    Returns the chroma height of the picture.
- unsigned int LumaDepth () const
    Returns the luma depth.
- unsigned int ChromaDepth () const
    Returns the chroma depth.
- const PictureSort & PicSort () const
    Returns the type of the picture.
- int PictureNum () const
    Returns the number of the picture (in time order).
- int RetiredPictureNum () const
    Returns the retired reference picture number.
- bool IsBPicture () const
    Returns whether the picture is bi-directionally predicted by checking references.
- int ExpiryTime () const
    Returns the number of pictures after the current picture number after which the picture can be discarded.
- bool Output () const
    Returns an indication of whether the picture has been output yet.
- const std::vector< int > & Refs () const
    Returns a const C++ reference to the set of reference picture numbers (will be empty if the picture is an I picture).
- std::vector< int > & Refs ()
    Returns non-const C++ referece to the vector of reference pictures, to allow them to be set.
- unsigned int NumRefs () const
    Return the number of reference pictures.
- PictureType GetPictureType () const
    Returns type of picture (see enum).
- ReferenceType GetReferenceType () const
    Returns reference picture type (see enum).
- bool UsingAC () const
    Returns true is entropy coding using Arithmetic coding.
- void SetPicSort (const PictureSort &ps)
    Sets the type of picture.
- void SetPictureType (const PictureType ftype)
    Sets the picture to be Intra/Inter.
- void SetReferenceType (const ReferenceType rtype)
    Sets the picture to be a reference or not.
- void SetPictureNum (const int fn)
    Sets the picture number.
- void SetExpiryTime (const int expt)
    Sets how long the picture will stay in the buffer (encoder only).
- void SetAsOutput ()
    Sets a flag to indicate that the picture has been output.
- void SetCFormat (ChromaFormat cf)
    Sets the chroma format.
- void SetXl (int xlen)
    Sets the picture width.
- void SetYl (int ylen)
    Sets the picture height.
- void SetLumaDepth (unsigned int luma_depth)
    Set Luma Depth.
- void SetChromaDepth (unsigned int chroma_depth)
    Set Chroma Depth.
- void SetRetiredPictureNum (int retd_fnum)
    Sets the retired reference picture number.
- void SetUsingAC (bool using_ac)
    Sets the arithmetic coding flag.

## Private Attributes

- ChromaFormat m_cformat
    The chroma format.
- PictureSort m_psort
    The picture sort.
- std::vector< int > m_refs
    The set of picture numbers of reference pictures.
- int m_expiry_time
    The number of pictures, after the current picture number, after the (de)coding of which the picture can be deleted.
- int m_fnum
    The picture number, in temporal order.
- PictureType m_picture_type
    Picture type.
- ReferenceType m_reference_type
    Reference type.
- bool m_output
    True if the picture has been output, false if not.
- int m_retd_fnum
    The picture number of the retired picture.
- int m_xl
    Picture luma width.
- int m_yl
    Picture luma height.
- int m_cxl
    Picture chroma width.
- int m_cyl
    Picture chroma height.
- unsigned int m_luma_depth
    Luma depth - number of bits required for lumz.
- unsigned int m_chroma_depth
    chroma depth - number of bits required for luma
- bool m_using_ac
    arithmetic coding flag

## Constructor & Destructor Documentation

dirac::PictureParams::PictureParams | ( |  | ) |

dirac::PictureParams::PictureParams | ( | const ChromaFormat & | cf,
|  | int | xlen,
|  | int | ylen,
|  | unsigned int | luma_depth,
|  | unsigned int | chroma_depth |
| ) |  |  |

Picture chroma format is set Picture sort defaults to I picture.

dirac::PictureParams::PictureParams | ( | const ChromaFormat & | cf,
|  | const PictureSort & | fs |
| ) |  |  |

Picture chroma format and picture sort are set.

dirac::PictureParams::PictureParams | ( | const SourceParams & | sparams | ) |

Constructor. Parameters are derived from the source parameters

## Member Function Documentation

const ChromaFormat& dirac::PictureParams::CFormat | ( |  | ) | const`[inline]`

References m_cformat.

int dirac::PictureParams::Xl | ( |  | ) | const`[inline]`

References m_xl.

int dirac::PictureParams::Yl | ( |  | ) | const`[inline]`

References m_yl.

int dirac::PictureParams::ChromaXl | ( |  | ) | const`[inline]`

References m_cxl.

int dirac::PictureParams::ChromaYl | ( |  | ) | const`[inline]`

References m_cyl.

unsigned int dirac::PictureParams::LumaDepth | ( |  | ) | const`[inline]`

References m_luma_depth.

unsigned int dirac::PictureParams::ChromaDepth | ( |  | ) | const`[inline]`

References m_chroma_depth.

const PictureSort& dirac::PictureParams::PicSort | ( |  | ) | const`[inline]`

References m_psort.

int dirac::PictureParams::PictureNum | ( |  | ) | const`[inline]`

References m_fnum.

int dirac::PictureParams::RetiredPictureNum | ( |  | ) | const`[inline]`

References m_retd_fnum.

bool dirac::PictureParams::IsBPicture | ( |  | ) | const

int dirac::PictureParams::ExpiryTime | ( |  | ) | const`[inline]`

References m_expiry_time.

bool dirac::PictureParams::Output | ( |  | ) | const`[inline]`

References m_output.

const std::vector<int>& dirac::PictureParams::Refs | ( |  | ) | const`[inline]`

References m_refs.

std::vector<int>& dirac::PictureParams::Refs | ( |  | ) | `[inline]`

References m_refs.

unsigned int dirac::PictureParams::NumRefs | ( |  | ) | const`[inline]`

References m_refs.

PictureType dirac::PictureParams::GetPictureType | ( |  | ) | const`[inline]`

References m_picture_type.

ReferenceType dirac::PictureParams::GetReferenceType | ( |  | ) | const`[inline]`

References m_reference_type.

bool dirac::PictureParams::UsingAC | ( |  | ) | const`[inline]`

References m_using_ac.

void dirac::PictureParams::SetPicSort | ( | const PictureSort & | ps | ) |

Referenced by dirac::Picture::SetPictureSort().

void dirac::PictureParams::SetPictureType | ( | const PictureType | ftype | ) |

Referenced by dirac::Picture::SetPictureType().

void dirac::PictureParams::SetReferenceType | ( | const ReferenceType | rtype | ) |

Referenced by dirac::Picture::SetReferenceType().

void dirac::PictureParams::SetPictureNum | ( | const int | fn | ) | `[inline]`

References m_fnum.

void dirac::PictureParams::SetExpiryTime | ( | const int | expt | ) | `[inline]`

References m_expiry_time.

void dirac::PictureParams::SetAsOutput | ( |  | ) | `[inline]`

References m_output.

void dirac::PictureParams::SetCFormat | ( | ChromaFormat | cf | ) | `[inline]`

References m_cformat.

void dirac::PictureParams::SetXl | ( | int | xlen | ) |

void dirac::PictureParams::SetYl | ( | int | ylen | ) |

void dirac::PictureParams::SetLumaDepth | ( | unsigned int | luma_depth | ) | `[inline]`

References m_luma_depth.

void dirac::PictureParams::SetChromaDepth | ( | unsigned int | chroma_depth | ) | `[inline]`

References m_chroma_depth.

void dirac::PictureParams::SetRetiredPictureNum | ( | int | retd_fnum | ) | `[inline]`

References m_retd_fnum.

void dirac::PictureParams::SetUsingAC | ( | bool | using_ac | ) | `[inline]`

References m_using_ac.

## Member Data Documentation

ChromaFormat dirac::PictureParams::m_cformat`[private]`

Referenced by CFormat(), and SetCFormat().

PictureSort dirac::PictureParams::m_psort`[private]`

Referenced by PicSort().

std::vector<int> dirac::PictureParams::m_refs`[private]`

Referenced by NumRefs(), and Refs().

int dirac::PictureParams::m_expiry_time`[private]`

Referenced by ExpiryTime(), and SetExpiryTime().

int dirac::PictureParams::m_fnum`[private]`

Referenced by PictureNum(), and SetPictureNum().

PictureType dirac::PictureParams::m_picture_type`[private]`

Referenced by GetPictureType().

ReferenceType dirac::PictureParams::m_reference_type`[private]`

Referenced by GetReferenceType().

bool dirac::PictureParams::m_output`[private]`

Referenced by Output(), and SetAsOutput().

int dirac::PictureParams::m_retd_fnum`[mutable, private]`

Referenced by RetiredPictureNum(), and SetRetiredPictureNum().

int dirac::PictureParams::m_xl`[private]`

Referenced by Xl().

int dirac::PictureParams::m_yl`[private]`

Referenced by Yl().

int dirac::PictureParams::m_cxl`[private]`

Referenced by ChromaXl().

int dirac::PictureParams::m_cyl`[private]`

Referenced by ChromaYl().

unsigned int dirac::PictureParams::m_luma_depth`[private]`

Referenced by LumaDepth(), and SetLumaDepth().

unsigned int dirac::PictureParams::m_chroma_depth`[private]`

Referenced by ChromaDepth(), and SetChromaDepth().

bool dirac::PictureParams::m_using_ac`[private]`

Referenced by SetUsingAC(), and UsingAC().

The documentation for this class was generated from the following file:

- common.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.